<?php
class ControllerShippingSfc extends Controller {
	private $error = array(); 
	
	public function index() {   
		$this->load->language('shipping/sfc');

		$this->document->setTitle($this->language->get('heading_title'));
		
		$this->load->model('setting/setting');
				
		if (($this->request->server['REQUEST_METHOD'] == 'POST') && ($this->validate())) {
			$this->model_setting_setting->editSetting('sfc', $this->request->post);		
					
			$this->session->data['success'] = $this->language->get('text_success');
						
			$this->redirect(HTTPS_SERVER . 'index.php?route=extension/shipping&token=' . $this->session->data['token']);
		}
				
		$this->data['heading_title'] = $this->language->get('heading_title');

		$this->data['text_enabled'] = $this->language->get('text_enabled');
		$this->data['text_disabled'] = $this->language->get('text_disabled');
		$this->data['text_all_zones'] = $this->language->get('text_all_zones');
		$this->data['text_none'] = $this->language->get('text_none');
		
		$this->data['entry_country'] = $this->language->get('entry_xml_contry');
		$this->data['entry_status'] = $this->language->get('entry_status');
		$this->data['entry_rate'] = $this->language->get('entry_rate');
		$this->data['entry_currency'] = $this->language->get('entry_currency');
		$this->data['entry_mode'] = $this->language->get('entry_mode');
		$this->data['entry_cost'] = $this->language->get('entry_cost');
		$this->data['entry_tax'] = $this->language->get('entry_tax');
		$this->data['entry_geo_zone'] = $this->language->get('entry_geo_zone');
		$this->data['entry_status'] = $this->language->get('entry_status');
		$this->data['entry_sort_order'] = $this->language->get('entry_sort_order');
		
		$this->data['button_save'] = $this->language->get('button_save');
		$this->data['button_cancel'] = $this->language->get('button_cancel');

		$this->data['tab_general'] = $this->language->get('tab_general');

 		if (isset($this->error['warning'])) {
			$this->data['error_warning'] = $this->error['warning'];
		} else {
			$this->data['error_warning'] = '';
		}

  		$this->data['breadcrumbs'] = array();

   		$this->data['breadcrumbs'][] = array(
       		'href'      => HTTPS_SERVER . 'index.php?route=common/home&token=' . $this->session->data['token'],
       		'text'      => $this->language->get('text_home'),
      		'separator' => FALSE
   		);

   		$this->data['breadcrumbs'][] = array(
       		'href'      => HTTPS_SERVER . 'index.php?route=extension/shipping&token=' . $this->session->data['token'],
       		'text'      => $this->language->get('text_shipping'),
      		'separator' => ' :: '
   		);
		
   		$this->data['breadcrumbs'][] = array(
       		'href'      => HTTPS_SERVER . 'index.php?route=shipping/sfc&token=' . $this->session->data['token'],
       		'text'      => $this->language->get('heading_title'),
      		'separator' => ' :: '
   		);
		
		$this->data['action'] = HTTPS_SERVER . 'index.php?route=shipping/sfc&token=' . $this->session->data['token'];
		
		$this->data['cancel'] = HTTPS_SERVER . 'index.php?route=extension/shipping&token=' . $this->session->data['token'];
		
		
		$this->data['currencies'] = array();

	
		$this->load->model('localisation/currency');
		
		$currency_total = $this->model_localisation_currency->getTotalCurrencies();

		$results = $this->model_localisation_currency->getCurrencies();

		foreach ($results as $result) {
			$this->data['currencies'][] = array(
				'currency_id'   => $result['currency_id'],
				'title'         => $result['title'] . (($result['code'] == $this->config->get('config_currency')) ? $this->language->get('text_default') : NULL),
				'code'          => $result['code'],
				'value'         => $result['value'],
				'selected'      => isset($this->request->post['selected']) && in_array($result['currency_id'], $this->request->post['selected'])
				
			);
		}	
		
		define('REQUIRECOUNTRYURL','http://www.sendfromchina.com/shipfee/country_list');//http require URL  for iship country
			$doc = new DOMDocument();
			$doc->load( REQUIRECOUNTRYURL ); 
			$dataset = $doc->getElementsByTagName( "country" ); 	

			$this->data['countries'] = array();		
			
			foreach( $dataset as $row ){ 
				$countryNames = $row->getElementsByTagName( "englishname" );
				$this->data['countries'][] = array(
					'countryNm' => $countryNames->item(0)->nodeValue
				);	
			}
			
		define('REQUIRESHIPTYPE','http://www.sendfromchina.com/shipfee/ship_type_list');
		
		$doc = new DOMDocument();
		$doc->load( REQUIRESHIPTYPE ); 
		$dataArr = $doc->getElementsByTagName( "shiptype" ); 		
		$this->data['methods'] = array();		
		foreach( $dataArr as $row ){ 
			$en_names = $row->getElementsByTagName( "cn_name" );
			$en_name = $en_names->item(0)->nodeValue; 
			$method_codes = $row->getElementsByTagName( "method_code" );
			$method_code = $method_codes->item(0)->nodeValue;
			$this->data['methods'][] = array(
					'code' => $method_code,
					'name' => $en_name
			);			
            $sfc_mothod='sfc_'.$method_code;
			if (isset($this->request->post[$sfc_mothod])) {
				$this->data[$sfc_mothod] = $this->request->post[$sfc_mothod];
			} else {
				$this->data[$sfc_mothod] = $this->config->get($sfc_mothod);
			}
		 }
		 
		if (isset($this->request->post['sfc_currency'])) {
			$this->data['sfc_currency'] = $this->request->post['sfc_currency'];
		} else {
			$this->data['sfc_currency'] = $this->config->get('sfc_currency');
		}
 
		if (isset($this->request->post['sfc_countryName'])) {
			$this->data['sfc_countryName'] = $this->request->post['sfc_countryName'];
		} else {
			$this->data['sfc_countryName'] = $this->config->get('sfc_countryName');
		}

		if (isset($this->request->post['sfc_rate'])) {
			$this->data['sfc_rate'] = $this->request->post['sfc_rate'];
		} else {
			$this->data['sfc_rate'] = $this->config->get('sfc_rate');
		}

		if (isset($this->request->post['sfc_status'])) {
			$this->data['sfc_status'] = $this->request->post['sfc_status'];
		} else {
			$this->data['sfc_status'] = $this->config->get('sfc_status');
		}
		
		if (isset($this->request->post['sfc_sort_order'])) {
			$this->data['sfc_sort_order'] = $this->request->post['sfc_sort_order'];
		} else {
			$this->data['sfc_sort_order'] = $this->config->get('sfc_sort_order');
		}				

		$this->template = 'shipping/sfc.tpl';
		$this->children = array(
			'common/header',	
			'common/footer'	
		);
		unset($doc);
		
		$this->response->setOutput($this->render(TRUE), $this->config->get('config_compression'));
	}
	
	private function validate() {
		if (!$this->user->hasPermission('modify', 'shipping/sfc')) {
			$this->error['warning'] = $this->language->get('error_permission');
		}
		
		if (!$this->error) {
			return TRUE;
		} else {
			return FALSE;
		}	
	}
}
?>