<?php
class ModelShippingSfc extends Model {
	function getQuote($address,$code) {
		$method_data = array();
		$method_data=$this->getSFCQuote((int)$address['country_id'], $this->cart->getWeight(),$code);
		
		return $method_data;
	}
	
	public function getCurrencyCode($currencyID) {
		$query = $this->db->query("SELECT code FROM " . DB_PREFIX . "currency WHERE currency_id=".(int)$currencyID);
		if($query->row){
			return $query->row['code'];
		}
	}
	
	public function getWeightCode($weight_class_id) {
		$query = $this->db->query("SELECT * FROM " . DB_PREFIX . "weight_class wc LEFT JOIN " . DB_PREFIX . "weight_class_description wcd ON (wc.weight_class_id = wcd.weight_class_id) WHERE wcd.language_id = '" . (int)$this->config->get('config_language_id') . "' AND wcd.weight_class_id='".$weight_class_id."'" );
		if($query->row){
			return $query->row['unit'];
		}
	}

	public function getSFCQuote($country_id,$weight,$code) {
		$query = $this->db->query("SELECT DISTINCT * FROM " . DB_PREFIX . "country WHERE country_id = '" . (int)$country_id . "'");
		
		$this->load->model('shipping/sfc');
		
		$sfc_cny  =    $this->model_shipping_sfc->getCurrencyCode( $this->config->get('sfc_currency'));
	//	$sfc_weight =  $this->model_shipping_sfc->getWeightCode( $this->config->get('config_weight_class'));
		
		if(isset($sys_current_weight_id))
			$sfc_weight =  $this->model_shipping_sfc->getWeightCode( $sys_current_weight_id);
		else
			$sfc_weight =  $this->config->get('config_weight_class');
		//throw new exception($sfc_weight);
		$sys_current_weight='kg';
		
		//$sys_current_weight='kg';
		
		$weight=$this->weight->convert($weight,$sfc_weight,$sys_current_weight);
		
		$profile = '?country='.$query->row['name'].'&weight='.$weight.'&mode='.$code;
		
		if (isset($this->request->get['currency'])) {
			$sys_currency=$this->request->get['currency'];
    	} elseif ((isset($this->session->data['currency']))) {
      		$sys_currency=$this->session->data['currency'];
    	} elseif ((isset($this->request->cookie['currency']))) {
      		$sys_currency=$this->request->cookie['currency'];
    	} else {
      		$this->session->data['currency']=$this->config->get('config_currency');
    	}
		
		$sys_default =$this->config->get('config_currency'); //sys_currency default
		
		$doc = new DOMDocument();
			if(defined('REQUIRERATE')) {
				$doc = new DOMDocument();
				$doc->load( REQUIRERATE .$profile); 
				}
			else {
				define('REQUIRERATE','http://www.sendfromchina.com/shipfee/out_rates');
				$doc = new DOMDocument();
				$doc->load( REQUIRERATE .$profile); 
			}
		
			// Load the call and capture the document returned by sendfromchina.com API
		$dataset = $doc->getElementsByTagName("rate"); 	
		$method = array();
		
		foreach($dataset as $row ){ 
			$totalfees  = $row->getElementsByTagName( "totalfee" );
			$deliverytimes  = $row->getElementsByTagName( "deliverytime" );
			$shiptypename  = $row->getElementsByTagName("shiptypename");
			$shiptypecode  = $row->getElementsByTagName("shiptypecode");
			$totalfees  = $row->getElementsByTagName( "totalfee" );
			if(isset($totalfees->item(0)->nodeValue)&&isset($deliverytimes->item(0)->nodeValue)&&isset($shiptypename->item(0)->nodeValue)&&isset($shiptypecode->item(0)->nodeValue)){
			    $cost=$totalfees->item(0)->nodeValue*($this->config->get('sfc_rate')/100.00);
				$cost=$this->currency->convert($cost,$sfc_cny,$sys_default);
				if($cost!=0){
					$method = array(
							'code' => $shiptypecode->item(0)->nodeValue,
							'name' => $shiptypename->item(0)->nodeValue,
							//'totalfee' =>$this->currency->format($this->currency->convert($cost,$sys_default,$sys_currency)),
							'totalfee' => $cost,
							'deliverytime'  => $deliverytimes->item(0)->nodeValue
						);	
					}
				}
		}
		
		if ($this->config->get('sfc_status')) {
			$status = TRUE;
		} else {
			$status = FALSE;
		}
	
		$method_data = array();
		if(isset($method)) {
		   if(isset($method['code'])) {
		   $this->language->load('shipping/sfc');
		   if ($status) {
				$quote_data = array();
			
				$quote_data[$code] = array(
					'code'           => 'sfc_'.$method['code'].'.'.$method['code'],
					'title'        =>'<img src="http://www.sfcservice.com/app/images/shippingmethod/'.strtolower($method['code']).'.gif" height="20px" />', 
					// .'      <span style="color:#990000;">'.$this->language->get('text_estimated').' '.$method['deliverytime'].' '.$this->language->get('text_days').'</span>'
					'cost'         => $method['totalfee'],
					'tax_class_id' => $this->config->get('tax_class_id'),
					'text'         => $this->currency->format($method['totalfee']),
				);

				$method_data = array(
					'code'         => $method['code'],
					'title'      => $method['name'],
					'quote'      => $quote_data,
					'sort_order' => $this->config->get('sfc_sort_order'),
					'error'      => FALSE
				);
			}
			}
		}
		unset($doc);
		return $method_data;
	}
}
?>